/* analyseur lexical associe au langage SQL */
P [A-Za-z]
Q [A-Za-z0-9_]
R {P}{Q}*
N [0-9]
D [1-9]
I ({D}{N}*|0)
%{
#include "psql.h"
extern int lineno;
%}
%%
[sS][eE][lL][eE][cC][tT] { return SELECT; }
[fF][rR][oO][mM] { return FROM; }
[wW][hH][eE][rR][eE] { return WHERE; }
[aA][nN][dD] { return AND; }
== { return EQ; }
!= { return NEQ; }
{R}/(\.{I}) { yylval.str = (char *)malloc(strlen(yytext)+1);
		strcpy(yylval.str,yytext);
		return IDENT_PT;
		}
{R} { yylval.str = (char *)malloc(strlen(yytext)+1);
		strcpy(yylval.str,yytext);
		return IDENT;
		}
{I} { sscanf(yytext,"%d", &yylval.integer);
		return INTEGER;
		} 
\"[^\"\n]*\" { yylval.str = (char *)malloc(strlen(yytext)-1);
		yytext[strlen(yytext)-1]=0;
		strcpy(yylval.str,yytext+1);
		return STRING;
		}
[ \t] { /* ignore les blancs et les tabulations */ }
\n { lineno++; }
. { return (int)yytext[0]; }
%%
#include <stdio.h>
int main() {
  yylex() ; /* pas de return */
  return(1);
}

